library(shipunov)

aa <- read.table("../../../../data/picramniaceae_dna.txt", sep="\t", h=T, as.is=T, quote="")

aa <- aa[order(aa$FRAGMENT, aa$SPECIES.NEW), ]
aa <- aa[aa$SELECT == 1 | is.na(aa$SELECT), ]
aa <- aa[!aa$SOURCE %in% c("GENBANK", "BOLD"), ]
aa <- aa[, c("SPECIES.NEW", "SEQUENCE.ID", "FRAGMENT")]
names(aa) <- c("TAXA", "ID", "FRAGMENT")

split.ids <- c(suppressWarnings(do.call(rbind, strsplit(aa$ID, ", "))))
row.names(aa) <- NULL
long.aa <- data.frame(ID=split.ids, aa[, c("TAXA", "FRAGMENT")])
bb <- Aggregate1(long.aa, long.aa$ID, function(.x) paste(unique(sort(.x)), collapse=", "))

write.table(bb, row.names=FALSE, quote=FALSE, sep="\t", file="shipunov_et_al_picramniaceae_table.txt")

