Make.treesc <- function(treelist) {
## LABELS
tl <- lapply(treelist, `[[`, "tip.label")
## remove ids
tl <- lapply(tl, function(.x) sub("__.*$", "", .x))
## remove triple names
tl <- lapply(tl, function(.x) gsub("^([^_]*_[^_]*)_.*$", "\\1", .x))
## restore species names
tl <- lapply(tl, make.unique)
## make unique to prepare for duplicates removal
tl <- lapply(tl, function(.x) gsub("_", " ", .x))
## return changed labels back to trees
for (n in 1:length(treelist)) treelist[[n]]$tip.label <- tl[[n]]
## TREES
## drop duplicates
treelist <- lapply(treelist, function(.x) ape::drop.tip(.x, .x$tip.label[grepl("\\.[1-9]", .x$tip.label)]))
## drop " sp." tips
treelist <- lapply(treelist, function(.x) ape::drop.tip(.x, .x$tip.label[grepl(" sp\\.", .x$tip.label)]))
## what is in all
allt <- table(unlist(lapply(treelist, `[[`, "tip.label")))
all <- names(allt)[allt == length(treelist)]
## drop what is not in all
lapply(treelist, function(.x) ape::drop.tip(.x, .x$tip.label[!.x$tip.label %in% all]))
}
