library(shipunov)

setwd("20_sets")
system(paste0("mafft ", "its.fasta", " > ", "../30_alignments/", "its_mafft.fasta"))
system(paste0("clustalo -i ", "its.fasta", " --force -o ", "../30_alignments/", "its_clustalo.fasta", " -v"))
setwd("..")

setwd("30_alignments")
dna <- structure(vector("list", 2), names=c("its_mafft", "its_clustalo"))
for (f in names(dna)) {
dna[[f]] <- Read.fasta(paste0(f, ".fasta"))
bb <- do.call(rbind, strsplit(dna[[f]]$sequence, split=""))
dd <- apply(bb, 2, function(.x) sum(.x == "-")/nrow(bb))
ee <- runmed(dd, 3) < 0.5 # trimming treshold: three subsequent sequence positions have more then 50% of non-gaps
left <- min(which(ee == TRUE))
right <- max(which(ee == TRUE))
ff <- bb[,left:right]
dna[[f]]$sequence <- apply(ff, 1, paste, collapse="")
Write.fasta(dna[[f]], file=paste0("../31_alignments_trimmed/", f, ".fasta"))
}
setwd("..")

setwd("31_alignments_trimmed")
dna <- structure(vector("list", 3), names=c("its", "its_mafft", "its_clustalo"))
for (f in names(dna)) {
dna[[f]] <- Read.fasta(paste0(f, ".fasta"))
dna[[f]]$sequence <- toupper(dna[[f]]$sequence)
dna[[f]] <- dna[[f]][order(dna[[f]]$name), ]
}
dna.new <- data.frame(name=dna[[1]]$name, sequence=do.call(paste0, lapply(dna, `[[`, "sequence")))
Write.fasta(dna.new, file="its.fasta") # !!! overwrite "its"
setwd("..")
